package edu.thi.phga.aparapi_test;

import com.aparapi.device.OpenCLDevice;

public class App {
  public static int choice;
  public static OpenCLDevice device;
  private static void printHeader(final String txt) {
    final String spacer =
      "######################################################################";
    System.out.printf("%s\n%s\n", spacer, txt);
  }
  public static void main( String[] args ) {
    // System.out.println("Running the OpenCL Tasks");
    if (args.length == 0) {
      App.choice = 0;
    } else {
      App.choice = Integer.parseInt(args[0]) - 1;
    }
    App.device = Devices.selectDevice();

    int target = 0;
    if (args.length > 1) {
      target = Integer.parseInt(args[1]);
    }
    int shift = 25;
    if (args.length > 2) {
      shift = Integer.parseInt(args[2]);
    }
    final int[] b = new int[1 << shift];
    switch (target) {
      case 0:
        OpenCLGetMemoryInfo.getInfo();
        OpenCLSizeTest.start(8);
        break;
        // PRIMES
      case 10:
        printHeader("FindPrimes (Seriell, Parallel, OpenCL)");
        // Ab 1 << 14 stimmt es nicht mehr
        // final int[] a = {8, 5, 6, 2, 3, 7, 1, 4};
        // CPU is faster than GPU...
        FindPrimes.start();
        FindPrimesThreads.start();
        FindPrimesOpenCL.start();
        break;
        // REDUCE
      case 20:
        java.util.Arrays.fill(b, 1);
        OpenCLReduce1.start(b);
        java.util.Arrays.fill(b, 1);
        OpenCLReduce2.start(b);
        java.util.Arrays.fill(b, 1);
        OpenCLReduce3.start(b);
        java.util.Arrays.fill(b, 1);
        OpenCLReduce4.start(b);
        java.util.Arrays.fill(b, 1);
        OpenCLReduce5.start(b);
        break;
      case 21:
        java.util.Arrays.fill(b, 1);
        OpenCLReduce1.start(b);
        break;
      case 22:
        java.util.Arrays.fill(b, 1);
        OpenCLReduce2.start(b);
        break;
      case 23:
        java.util.Arrays.fill(b, 1);
        OpenCLReduce3.start(b);
        break;
      case 24:
        java.util.Arrays.fill(b, 1);
        OpenCLReduce4.start(b);
        break;
      case 25:
        java.util.Arrays.fill(b, 1);
        OpenCLReduce5.start(b);
        break;
        // PREFIX
      case 30:
        // Up to 1 << 27
        java.util.Arrays.fill(b, 1);
        OpenCLPrefix1.start(b);
        // Up to 1 << 28
        java.util.Arrays.fill(b, 1);
        OpenCLPrefix2.start(b);
        break;
      case 31:
        // Up to 1 << 27
        java.util.Arrays.fill(b, 1);
        OpenCLPrefix1.start(b);
        break;
      case 32:
        // Up to 1 << 28
        java.util.Arrays.fill(b, 1);
        OpenCLPrefix2.start(b);
        break;
    }
  }
}
