package edu.thi.phga.aparapi_test;

import com.aparapi.Kernel;
import com.aparapi.Range;


public class OpenCLPrefix1 {

  public static void start(final int[] a) {
    int N = a.length;
    int b[] = new int[N * 2];
    java.util.Arrays.fill(b, 1);
    Range r = Range.create(App.device, N, 4);
    OpenCLPrefix1Kernel k = new OpenCLPrefix1Kernel(b);
    k.setExplicit(true);
    k.setStepSize(1);
    k.execute(r);
    k.toggleIndex();
    double ct = k.getConversionTime();
    // k.get(b);
    // for (int i = 0; i < b.length; i++) {
    //   System.out.printf("%c[%d] = %d\n", (i < b.length / 2) ? 'A' : 'B', i, b[i]);
    // }

    for (int n = 2; n < N; n *= 2) {
      k.setStepSize(n);
      k.execute(r);
      k.toggleIndex();
      // k.get(b);
      // for (int i = 0; i < b.length; i++) {
      //   System.out.printf("%c[%d] = %d\n", (i < b.length / 2) ? 'A' : 'B', i, b[i]);
      // }
    }

    k.get(b);
    double et = k.getAccumulatedExecutionTime() - ct;

    int n = N + k.getIndex();
    System.out.printf("P1 - GOT: %d, %d, %d, TIME: %.2f ms\n",
      b[n - 3], b[n - 2], b[n - 1], et);
  }

  private static class OpenCLPrefix1Kernel extends Kernel {
    private int stepSize;
    private int index;
    private int N;
    private int[] a;

    public OpenCLPrefix1Kernel(int[] a) {
      this.a = a;
      this.N = a.length / 2;
    }

    public void setStepSize(int s) {
      this.stepSize = s;
    }

    public void toggleIndex() {
      index = N - index;
    }

    public int getIndex() {
      return index;
    }

    @Override
    public void run() {
      int i = getGlobalId();
      int out = N - index;
      if (i < stepSize) {
        a[out + i] = a[index + i];
      } else {
        a[out + i] = a[index + i] + a[index + i - stepSize];
      }
    }
  }
}
