package edu.thi.phga.aparapi_test;

import com.aparapi.Kernel;
import com.aparapi.Range;

public class OpenCLReduce2 {
  public static void start(int[] a) {
    int optimalSize = a.length / 2;
    int N = a.length;
    int[] gs = new int[optimalSize];

    Kernel k = new Kernel() {
        @Override
        public void run() {
          int size = N / getGlobalSize(); // 2, 4, 8, ...
          int i = getGlobalId() * size; // 2: 0 -> 0, 1 -> 2, 2 -> 4, 3 -> 6, ...

          gs[getGlobalId()] = size;

          a[i] += a[i + size / 2]; // 1, 2, 4, ..
        }
      };

    k.execute(Range.create(N / 2, optimalSize < 256 ? optimalSize : 256));
    double ct = k.getConversionTime();

    for (int n = N / 4; n >= 1; n /= 2) {
      k.execute(Range.create(n, n < 256 ? n : 256));
    }

    double et = k.getAccumulatedExecutionTime() - ct;
    System.out.printf("R2 - WANT: %d, GOT: %d, TIME: %.2f ms\n", a.length, a[0], et);

  }
}
