package edu.thi.phga.aparapi_test;

import com.aparapi.Kernel;
import com.aparapi.Range;

public class OpenCLSizeTest {
  public static void start(int n) {
    final int N = n;
    int[] res = new int[N];
    int[] gids = new int[N];
    int[] lids = new int[N];
    int[] gsizes = new int[N];
    int[] lsizes = new int[N];

    new Kernel() {
      @Override
      public void run() {
        int i = getGlobalId();

        int gi = getGlobalId();
        int li = getLocalId();
        int gs = getGlobalSize();
        int ls = getLocalSize();

        gids[i] = gi;
        lids[i] = li;
        gsizes[i] = gs;
        lsizes[i] = ls;

        res[i] = 10 + i;
      }
    }.execute(Range.create(N, 4));

    if (N < 3000) {
      for (int x = 0; x < N; x++) {
        System.out.printf("GI: %d, LI: %d, GSize: %d, LSize: %d, RES: %d\n",
          gids[x], lids[x], gsizes[x], lsizes[x], res[x]);

      }
    } else {
        System.out.printf("GI: %d, LI: %d, GSize: %d, LSize: %d, RES: %d\n",
          gids[0], lids[0], gsizes[0], lsizes[0], res[0]);
        System.out.printf("GI: %d, LI: %d, GSize: %d, LSize: %d, RES: %d\n",
          gids[N - 1], lids[N - 1], gsizes[N - 1], lsizes[N - 1], res[N - 1]);
    }
  }
}
