package edu.thi.phga.aparapi_test;

import com.aparapi.Kernel;
import com.aparapi.Range;
import com.aparapi.device.Device;

public class VAdd {
  public VAdd() {
    // System.setProperty("com.aparapi.enableShowGeneratedOpenCL", "true");
    int[] a = {1, 2, 3, 4};
    int[] b = {5, 6, 7, 8};
    int[] c = new int[a.length];

    Device device = Devices.selectDevice();
    Range r = Range.create(device, a.length);
    Kernel vak = new VAddKernel(a, b, c);
    vak.execute(r); // Execution erzwingen um ConversionTime zu erhalten
    final double ctime = vak.getConversionTime();
    final double etime = vak.getExecutionTime();

    System.out.println("Conversion Time: " + ctime + " ms");
    System.out.println("Execution Time: " + etime + " ms");
    System.out.println("Execution w/o Conversion Time: " + (etime - ctime) + " ms");

    vak.execute(r);
    final double etime2 = vak.getExecutionTime();
    System.out.println("Execution Time(2): " + etime2 + " ms");

    for (int i = 0; i < a.length; i++)
      System.out.printf("%d + %d = %2d\n", a[i], b[i], c[i]);
  }


  // CPU
  // Conversion Time: 309.714392 ms
  // Execution Time: 310.215247 ms
  // Execution w/o Conversion Time: 0.5008550000000014 ms
  // Execution Time(2): 0.103835 ms


  // GPU
  // Conversion Time: 249.313076 ms
  // Execution Time: 250.076624 ms
  // Execution w/o Conversion Time: 0.7635480000000143 ms
  // Execution Time(2): 0.075589 ms
}
